
-- return the window size
getWindowSize = getWindowSize or function()
	return 525, 395
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 58
	local kKnobSpaceV = 70
	local kPropertyTextFieldH = 20
	local kLabelSpaceV = 30
	local kDropdownW = 65
	local kTextW = 40

	local function knobGroup( LR, title, propertyId )
		g = group( title )
		local x = 0
		local y = 0
		
		g:add( paramButton( "Enable Note " .. LR,				"Note",				x, y, 50, 30 ) )
		x = x + kKnobSpace
		labelledDropDown( g, "Note On Mode " .. LR,				"Note On",			x, y + kLabelSpaceV, kDropdownW )
		labelledDropDown( g, "Note Off Mode " .. LR,			"Note Off",			x, y, kDropdownW )
		x = x + kDropdownW + 10
		labelledDropDown( g, "Gate Close Msg " .. LR,			"Gate Close",			x, y, kDropdownW )
		x = x + kDropdownW + 10
		local x2 = x
		smallKnobAndTextField( g, "Pitch Centre " .. LR,		"Centre",				x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Pitch Slope " .. LR,			"Slope",				x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Gate Threshold " .. LR,		"Threshold",			x, y, kTextW, "%.3f" )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Max Note Length " .. LR,		"Length",				x, y )
		x = x + kKnobSpace
		
		x = 0
		y = kKnobSpaceV

		g:add( paramButton( "Enable " .. LR,					"Enable",			x, y, 50, 30 ) )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Channel " .. LR,				"Channel",			x, y )

		x = x2 - kKnobSpace
		g:add( paramButton( "Enable CC " .. LR,					"CC",				x, y, 50, 30 ) )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Send CC " .. LR,			"CC #",					x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "CC Min " .. LR,			"CC Min",				x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "CC Max " .. LR,			"CC Max",				x, y, kTextW )
		x = x + kKnobSpace

		smallKnobAndTextField( g, "Max Rate " .. LR,		"Max Rate",				x, y, kTextW )
		x = x + kKnobSpace

		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel", 64003 )
	rightGroup = knobGroup( "R", "Right Channel", 64004 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase + kPropertyTextFieldH + pad
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad
	
	local prefsX = x
	local prefsY = y

	-- add directly positioned objects
	--

	-- add the prefs button
	
	local kPrefsW = 53

	local kLabelW = 55
	local kPortW = prefsX - pad - ( xbase + kLabelW + pad )
	x = xbase
	y = windowEdgePad

	add( propertyTextField( 64100, "Enter MIDI destination", x+kLabelW+pad, y, kPortW, kPropertyTextFieldH ) )
	local lab = label( "Target:", x+0.5*kLabelW, y+0.5*(kPropertyTextFieldH+kTextFieldH), kLabelW, kTextFieldH )
	setLabelColour( lab )
	add( lab )
	x = prefsX
	add( midiBrowseButton( "Browse", "Browse for MIDI target", 64100, x, y, kPrefsW, kPropertyTextFieldH ) )
	y = y + kPropertyTextFieldH + pad
	add( luaButton( function() setStringProperty( 64100, "" ) end, "Clear", "Clear MIDI target", "push", x, y, kPrefsW, kPropertyTextFieldH ) )
	y = y + kPropertyTextFieldH + pad
	add( paramButton( "Send To Learner",	"Learner",		x, y, kPrefsW, kPropertyTextFieldH ) )

end		-- of createUI()
