
-- return the window size
getWindowSize = getWindowSize or function()
	return 550, 269
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 69
	local kKnobSpaceV = 70
	local kPropertyTextFieldH = 20
	
	local function knobGroup( LR, title, propertyId )
		g = group( title )
		x = 0
		g:add( paramButton( "Enable " .. LR,					"Enable",			x, 0, 50, 30 ) )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Threshold " .. LR,			"Threshold",		x, 0 )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Max Rate " .. LR,			"Max Rate",			x, 0 )
		x = x + kKnobSpace
		local kOSCPathWidth = 300
		g:add( propertyTextField( propertyId, "Enter OSC Path:", x, 0, kOSCPathWidth, kPropertyTextFieldH ) )
		local lab = label( "OSC Path", x+0.5*kOSCPathWidth, -14, 60, kTextFieldH )
		setLabelColour( lab )
		g:add( lab )
	
		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel", 64111 )
	rightGroup = knobGroup( "R", "Right Channel", 64112 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase + kPropertyTextFieldH + pad
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad
	
	local prefsX = x
	local prefsY = y

	-- add directly positioned objects
	--

	-- add the prefs button
	
	local kPrefsW = 53

	local kLabelW = 55
	local ww, wh = getWindowSize()
	local kPortW = ww - ( xbase + kLabelW + pad + pad + kPrefsW + windowEdgePad )
	x = xbase
	y = windowEdgePad

	add( propertyTextField( 64110, "Enter target address and port (e.g. 127.0.0.1:7000)", x+kLabelW+pad, y, kPortW, kPropertyTextFieldH ) )
	local lab = label( "Target:", x+0.5*kLabelW, y+0.5*(kPropertyTextFieldH+kTextFieldH), kLabelW, kTextFieldH )
	setLabelColour( lab )
	add( lab )
	if isMac then
		add( bonjourButton( "Browse", "Browse for OSC target", 64110, x+kLabelW+pad+kPortW+pad, y, kPrefsW, kPropertyTextFieldH ) )
	end

end		-- of createUI()
